## autofdo 0.14

=== chromiumos-wide-profiling/Makefile ===
# Copyright (c) 2012 The Chromium OS Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

include common.mk

BASE_VER ?= 293518
PC_DEPS = openssl protobuf libchrome-$(BASE_VER)
PC_CFLAGS := $(shell $(PKG_CONFIG) --cflags $(PC_DEPS))
PC_LIBS := $(shell $(PKG_CONFIG) --libs $(PC_DEPS))

CPPFLAGS += -Iperf $(PC_CFLAGS) -D__STDC_FORMAT_MACROS
LDLIBS += $(PC_LIBS)

TEST_SOURCES = address_mapper_test.cc conversion_utils_test.cc \
	       perf_parser_test.cc perf_reader_test.cc \
	       perf_serializer_test.cc perf_recorder_test.cc utils_test.cc

GENERATED_OBJECTS = perf_data.pb.o
GENERATED_HEADERS = $(GENERATED_OBJECTS:.pb.o=.pb.h)

COMMON_OBJECTS = address_mapper.o conversion_utils.o perf_parser.o \
		 perf_protobuf_io.o \
		 perf_reader.o perf_recorder.o perf_serializer.o utils.o \
		 $(GENERATED_OBJECTS)

COMMON_TEST_OBJECTS = test_utils.o

# Rule for compiling protobuf.
perf_data.pb.h perf_data.pb.cc: perf_data.proto
	protoc --cpp_out=. $^
clean: CLEAN(perf_data.pb.h perf_data.pb.cc)
$(eval $(call add_object_rules,perf_data.pb.o,CXX,cc))

# Dependencies on the protobuf.
quipper.o.depends \
perf_protobuf_io.o.depends \
perf_recorder.o.depends \
perf_serializer.o.depends: perf_data.pb.h

# Rule for compiling main quipper executable.
CXX_BINARY(quipper): quipper.o $(COMMON_OBJECTS)
clean: CLEAN(quipper)
all: CXX_BINARY(quipper)

# Template for unit tests.
define TEST_RULES_template
CXX_BINARY($(1)): LDLIBS += -lgtest -lgmock
CXX_BINARY($(1)): $(1).o $(COMMON_OBJECTS) $(COMMON_TEST_OBJECTS)
clean: CLEAN($(1))
tests: TEST(CXX_BINARY($(1)))
endef

TEST_BINS = $(patsubst $(SRC)/%.cc,%,$(wildcard $(SRC)/*_test.cc))
$(foreach prog,$(TEST_BINS),$(eval $(call TEST_RULES_template,$(prog))))

## autofdo 0.13

=== debian/changelog ===
autofdo (0.13-2build1) wily; urgency=medium

  * No-change rebuild against libgflags2v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 06 Aug 2015 18:52:24 +0000

autofdo (0.13-2) unstable; urgency=medium

  * debian/copyright: Add copyright for gflags and glog.

 -- Matthias Klose <doko@debian.org>  Wed, 29 Jul 2015 19:19:09 +0200

autofdo (0.13-1) unstable; urgency=low

  * Initial release (Closes: #783092).

 -- Matthias Klose <doko@debian.org>  Sun, 31 May 2015 15:51:41 +0200

=== debian/control ===
Source: autofdo
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
Uploaders: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 9), dh-autoreconf,
  libssl-dev, zlib1g-dev,
  libgoogle-glog-dev, libgflags-dev,
Standards-Version: 3.9.6
Homepage: https://github.com/google/autofdo

Package: autofdo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AutoFDO Profile Toolchain
 The package contains a tool to convert perf.data profile to AutoFDO
 profile that can be used by GCC and LLVM.

## autofdo 0.14

=== debian/changelog ===
autofdo (0.14-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Mon, 25 Jan 2016 19:03:23 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: autofdo
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
+Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9), dh-autoreconf,
   libssl-dev, zlib1g-dev,

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@  --with autoreconf

override_dh_auto_configure:
	rm -rf gflags
	rm -rf glog
	dh_auto_configure

=== debian/watch ===
version=3
https://github.com/google/autofdo/releases .*/archive/v(.*).tar.gz

## autofdo 0.15

=== debian/changelog ===
autofdo (0.15-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Wed, 01 Jun 2016 23:09:02 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper (>= 9), dh-autoreconf,
   libssl-dev, zlib1g-dev,
   libgoogle-glog-dev, libgflags-dev,
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: https://github.com/google/autofdo
 
 Package: autofdo

## autofdo 0.16

=== debian/changelog ===
autofdo (0.16-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sat, 05 Aug 2017 12:03:39 -0400

autofdo (0.15-2) unstable; urgency=medium

  * Non-maintainer upload.

 -- Matthias Klose <doko@debian.org>  Sat, 03 Dec 2016 13:32:38 +0100

## autofdo 0.18

=== debian/changelog ===
autofdo (0.18-1) unstable; urgency=medium

  * New upstream version.
  * Configure for LLVM profile support.

 -- Matthias Klose <doko@debian.org>  Tue, 20 Mar 2018 13:00:11 +0800

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,8 @@
 Build-Depends: debhelper (>= 9), dh-autoreconf,
   libssl-dev, zlib1g-dev,
   libgoogle-glog-dev, libgflags-dev,
-Standards-Version: 3.9.8
+  llvm-6.0-dev,
+Standards-Version: 4.1.3
 Homepage: https://github.com/google/autofdo
 
 Package: autofdo

=== debian/rules ===
--- 
+++ 
@@ -9,4 +9,4 @@
 override_dh_auto_configure:
 	rm -rf gflags
 	rm -rf glog
-	dh_auto_configure
+	dh_auto_configure -- --with-llvm=/usr/bin/llvm-config-6.0

## autofdo 0.19

=== third_party/perf_data_converter/src/Makefile ===
# Copyright (c) 2016, Google Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Google Inc. nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Google Inc. BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

CXX ?= g++

BASE_VER ?= 369476
PKG_CONFIG ?= pkg-config
PC_DEPS = openssl
PC_CFLAGS := $(shell $(PKG_CONFIG) --cflags $(PC_DEPS))
PC_LIBS := $(shell $(PKG_CONFIG) --libs $(PC_DEPS))

CWP = quipper
PROTOBUF = ../third_party/protobuf
GOOGLETEST = ../third_party/googletest

CXXFLAGS += -std=c++11 -g -Wall -Werror -Wall -Wno-error
CPPFLAGS += -Icompat \
		-I${CWP}/compat/ext \
		-I${CWP} \
		-I../third_party \
		-I../. -I. $(PC_CFLAGS) $(PROTOBUF_CFLAGS) $(GTEST_INCLUDES)
LDLIBS += -lelf -lpthread $(PC_LIBS) $(PROTOBUF_LIBS)

PROGRAMS = perf_to_profile
MAIN_SOURCES = $(PROGRAMS:%=%.cc)
MAIN_OBJECTS = $(MAIN_SOURCES:%.cc=%.o)

QUIPPER_LIBRARY_SOURCES = \
	address_mapper.cc binary_data_utils.cc buffer_reader.cc buffer_writer.cc \
	conversion_utils.cc compat/log_level.cc data_reader.cc \
	data_writer.cc dso.cc file_reader.cc file_utils.cc \
	base/logging.cc perf_option_parser.cc perf_data_utils.cc \
	perf_parser.cc perf_protobuf_io.cc perf_reader.cc perf_recorder.cc \
	perf_serializer.cc perf_stat_parser.cc run_command.cc \
	sample_info_reader.cc scoped_temp_path.cc string_utils.cc \
  huge_page_deducer.cc
QUIPPER_LIBRARY_SOURCES := \
	$(QUIPPER_LIBRARY_SOURCES:%=${CWP}/%)
CONVERTER_LIBRARY_SOURCES = perf_data_converter.cc perf_data_handler.cc \
														builder.cc perf_to_profile_lib.cc
LIBRARY_SOURCES = $(QUIPPER_LIBRARY_SOURCES) $(CONVERTER_LIBRARY_SOURCES)

QUIPPER_PROTOS = perf_data.proto perf_stat.proto
QUIPPER_PROTOS := $(QUIPPER_PROTOS:%=${CWP}/%)
CONVERTER_PROTOS = profile.proto
QUIPPER_GENERATED_SOURCES = $(QUIPPER_PROTOS:.proto=.pb.cc)
QUIPPER_GENERATED_HEADERS = $(QUIPPER_PROTOS:.proto=.pb.h)
GENERATED_SOURCES = $(CONVERTER_PROTOS:.proto=.pb.cc) \
	$(QUIPPER_GENERATED_SOURCES)
GENERATED_HEADERS = $(CONVERTER_PROTOS:.proto=.pb.h) \
	$(QUIPPER_GENERATED_HEADERS)

COMMON_SOURCES = $(GENERATED_SOURCES) $(LIBRARY_SOURCES)
COMMON_OBJECTS = $(COMMON_SOURCES:.cc=.o)

TEST_SOURCES = intervalmap_test.cc perf_data_converter_test.cc \
	perf_data_handler_test.cc perf_to_profile_lib_test.cc
TEST_BINARIES = $(TEST_SOURCES:.cc=)
TEST_OBJECTS = $(TEST_SOURCES:.cc=.o)

ALL_SOURCES = $(MAIN_SOURCES) $(COMMON_SOURCES) $(TEST_SOURCES)

INTERMEDIATES = $(ALL_SOURCES:.cc=.d*)

all: $(PROGRAMS)
	@echo Sources compiled!

# Protobuf dependence configuration
ifeq ($(wildcard ${PROTOBUF}/src/google/protobuf/descriptor.pb.h),)
# Protobuf module hasn't been populated, attempt using local installation.
PROTOC = protoc
PROTOBUF_DEP =
PROTOBUF_CFLAGS := $(shell $(PKG_CONFIG) --cflags protobuf)
PROTOBUF_LIBS := $(shell $(PKG_CONFIG) --libs protobuf)
else
# Use protobuf compiler and libraries from submodule.
PROTOC = ${PROTOBUF}/src/protoc
PROTOBUF_CFLAGS := -I${PROTOBUF}/src
PROTOBUF_LIBS := ${PROTOBUF}/src/.libs/libprotobuf.a  -lz
PROTOBUF_DEP := ${PROTOBUF}/src/.libs/libprotobuf.a
endif

${PROTOBUF}/configure:
	echo "[AUTOGEN] Preparing protobuf"
	(cd ${PROTOBUF} ; autoreconf -f -i -Wall,no-obsolete)

${PROTOBUF}/src/.libs/libprotobuf.a: ${PROTOBUF}/configure
	echo "[MAKE]    Building protobuf"
	(cd ${PROTOBUF} ; CC="$(CC)" CXX="$(CXX)" LDFLAGS="$(LDFLAGS_$(CONFIG)) -g $(PROTOBUF_LDFLAGS_EXTRA)" CPPFLAGS="$(PIC_CPPFLAGS) $(CPPFLAGS_$(CONFIG)) -g $(PROTOBUF_CPPFLAGS_EXTRA)" ./configure --disable-shared --enable-static $(PROTOBUF_CONFIG_OPTS))
	$(MAKE) -C ${PROTOBUF} clean
	$(MAKE) -C ${PROTOBUF}

# Googletest dependence configuration
ifeq ($(wildcard ${GOOGLETEST}/googletest/include/gtest/gtest.h),)
# Use local gtest includes, already on the system path
GTEST_INCLUDES =
GTEST_LIBS = -lgtest -lgmock
else
# Pick up gtest includes from submodule.
GTEST_INCLUDES = -I${GOOGLETEST}/googlemock/include -I${GOOGLETEST}/googletest/include
GTEST_LIBS = -I${GOOGLETEST}/googlemock ${GOOGLETEST}/googlemock/src/gmock-all.cc -I${GOOGLETEST}/googletest ${GOOGLETEST}/googletest/src/gtest-all.cc
endif

ifneq ($(MAKECMDGOALS),clean)
  -include $(ALL_SOURCES:.cc=.d)
endif

# Taken from:
# http://www.gnu.org/software/make/manual/make.html#Automatic-Prerequisites
%.d: %.cc $(GENERATED_HEADERS)
	@set -e; rm -f $@; \
	$(CXX) -MM $(CPPFLAGS) $(CXXFLAGS) $< > $@.$$$$; \
	sed 's,\($*\)\.o[ :]*,\1.o $@ : ,g' < $@.$$$$ > $@; \
	rm -f $@.$$$$

# Rule for compiling protobufs.
%.pb.h %.pb.cc: %.proto $(PROTOBUF_DEP)
	$(PROTOC) --cpp_out=`dirname $<` -I`dirname $<` $<

# Do not remove protobuf headers that were generated as dependencies of other
# modules.
.SECONDARY: $(GENERATED_HEADERS)

$(PROGRAMS): %: %.o $(COMMON_OBJECTS)
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -o $@ $^ $(LDFLAGS) $(LDLIBS)

$(TEST_BINARIES): %: %.o $(COMMON_OBJECTS)
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -o $@ $^ $(LDFLAGS) $(LDLIBS) $(GTEST_LIBS)

# build all unit tests
tests: $(TEST_BINARIES)

# make run_(test binary name) runs the unit test.
UNIT_TEST_RUN_BINARIES = $(TEST_BINARIES:%=run_%)
$(UNIT_TEST_RUN_BINARIES): run_%: %
	./$^

# run all unit tests
check: $(UNIT_TEST_RUN_BINARIES)

clean:
	rm -f *.d $(TESTS) $(GENERATED_SOURCES)  $(GENERATED_HEADERS) \
		$(TEST_OBJECTS) $(COMMON_OBJECTS) $(INTERMEDIATES) \
		$(MAIN_OBJECTS) $(PROGRAMS) $(TEST_BINARIES)

print-%:
	@echo $* = $($*)

=== third_party/protobuf/cmake/CMakeLists.txt ===
# Minimum CMake required
cmake_minimum_required(VERSION 2.8.12)

if(protobuf_VERBOSE)
  message(STATUS "Protocol Buffers Configuring...")
endif()

# CMake policies
cmake_policy(SET CMP0022 NEW)

if(POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
endif()

# Project
project(protobuf C CXX)

# Add c++11 flags for clang
set(CMAKE_CXX_FLAGS "-std=c++11")

# Options
option(protobuf_BUILD_TESTS "Build tests" ON)
option(protobuf_BUILD_EXAMPLES "Build examples" OFF)
option(protobuf_BUILD_PROTOC_BINARIES "Build libprotoc and protoc compiler" ON)
if (BUILD_SHARED_LIBS)
  set(protobuf_BUILD_SHARED_LIBS_DEFAULT ON)
else (BUILD_SHARED_LIBS)
  set(protobuf_BUILD_SHARED_LIBS_DEFAULT OFF)
endif (BUILD_SHARED_LIBS)
option(protobuf_BUILD_SHARED_LIBS "Build Shared Libraries" ${protobuf_BUILD_SHARED_LIBS_DEFAULT})
include(CMakeDependentOption)
cmake_dependent_option(protobuf_MSVC_STATIC_RUNTIME "Link static runtime libraries" ON
  "NOT protobuf_BUILD_SHARED_LIBS" OFF)
set(protobuf_WITH_ZLIB_DEFAULT ON)
option(protobuf_WITH_ZLIB "Build with zlib support" ${protobuf_WITH_ZLIB_DEFAULT})
set(protobuf_DEBUG_POSTFIX "d"
  CACHE STRING "Default debug postfix")
mark_as_advanced(protobuf_DEBUG_POSTFIX)
# User options
include(protobuf-options.cmake)

# Path to main configure script
set(protobuf_CONFIGURE_SCRIPT "../configure.ac")

# Parse configure script
set(protobuf_AC_INIT_REGEX
  "^AC_INIT\\(\\[([^]]+)\\],\\[([^]]+)\\],\\[([^]]+)\\],\\[([^]]+)\\]\\)$")
file(STRINGS "${protobuf_CONFIGURE_SCRIPT}" protobuf_AC_INIT_LINE
  LIMIT_COUNT 1 REGEX "^AC_INIT")
# Description
string(REGEX REPLACE        "${protobuf_AC_INIT_REGEX}" "\\1"
    protobuf_DESCRIPTION    "${protobuf_AC_INIT_LINE}")
# Version
string(REGEX REPLACE        "${protobuf_AC_INIT_REGEX}" "\\2"
    protobuf_VERSION_STRING "${protobuf_AC_INIT_LINE}")
# Contact
string(REGEX REPLACE        "${protobuf_AC_INIT_REGEX}" "\\3"
    protobuf_CONTACT        "${protobuf_AC_INIT_LINE}")
# Parse version tweaks
set(protobuf_VERSION_REGEX "^([0-9]+)\\.([0-9]+)\\.([0-9]+)-?(.*)$")
string(REGEX REPLACE     "${protobuf_VERSION_REGEX}" "\\1"
  protobuf_VERSION_MAJOR "${protobuf_VERSION_STRING}")
string(REGEX REPLACE     "${protobuf_VERSION_REGEX}" "\\2"
  protobuf_VERSION_MINOR "${protobuf_VERSION_STRING}")
string(REGEX REPLACE     "${protobuf_VERSION_REGEX}" "\\3"
  protobuf_VERSION_PATCH "${protobuf_VERSION_STRING}")
string(REGEX REPLACE     "${protobuf_VERSION_REGEX}" "\\4"
  protobuf_VERSION_PRERELEASE "${protobuf_VERSION_STRING}")

# Package version
set(protobuf_VERSION
  "${protobuf_VERSION_MAJOR}.${protobuf_VERSION_MINOR}.${protobuf_VERSION_PATCH}")

if(protobuf_VERSION_PRERELEASE)
  set(protobuf_VERSION "${protobuf_VERSION}-${protobuf_VERSION_PRERELEASE}")
endif()

if(protobuf_VERBOSE)
  message(STATUS "Configuration script parsing status [")
  message(STATUS "  Description : ${protobuf_DESCRIPTION}")
  message(STATUS "  Version     : ${protobuf_VERSION} (${protobuf_VERSION_STRING})")
  message(STATUS "  Contact     : ${protobuf_CONTACT}")
  message(STATUS "]")
endif()

add_definitions(-DGOOGLE_PROTOBUF_CMAKE_BUILD)

find_package(Threads REQUIRED)
if (CMAKE_USE_PTHREADS_INIT)
  add_definitions(-DHAVE_PTHREAD)
endif (CMAKE_USE_PTHREADS_INIT)

set(_protobuf_FIND_ZLIB)
if (protobuf_WITH_ZLIB)
  find_package(ZLIB)
  if (ZLIB_FOUND)
    set(HAVE_ZLIB 1)
    # FindZLIB module define ZLIB_INCLUDE_DIRS variable
    # Set ZLIB_INCLUDE_DIRECTORIES for compatible
    set(ZLIB_INCLUDE_DIRECTORIES ${ZLIB_INCLUDE_DIRECTORIES} ${ZLIB_INCLUDE_DIRS})
    # Using imported target if exists
    if (TARGET ZLIB::ZLIB)
      set(ZLIB_LIBRARIES ZLIB::ZLIB)
      set(_protobuf_FIND_ZLIB "if(NOT ZLIB_FOUND)\n  find_package(ZLIB)\nendif()")
    endif (TARGET ZLIB::ZLIB)
  else (ZLIB_FOUND)
    set(HAVE_ZLIB 0)
    # Explicitly set these to empty (override NOT_FOUND) so cmake doesn't
    # complain when we use them later.
    set(ZLIB_INCLUDE_DIRECTORIES)
    set(ZLIB_LIBRARIES)
  endif (ZLIB_FOUND)
endif (protobuf_WITH_ZLIB)

if (HAVE_ZLIB)
  add_definitions(-DHAVE_ZLIB)
endif (HAVE_ZLIB)

if (protobuf_BUILD_SHARED_LIBS)
  set(protobuf_SHARED_OR_STATIC "SHARED")
else (protobuf_BUILD_SHARED_LIBS)
  set(protobuf_SHARED_OR_STATIC "STATIC")
  # In case we are building static libraries, link also the runtime library statically
  # so that MSVCR*.DLL is not required at runtime.
  # https://msdn.microsoft.com/en-us/library/2kzt1wy3.aspx
  # This is achieved by replacing msvc option /MD with /MT and /MDd with /MTd
  # http://www.cmake.org/Wiki/CMake_FAQ#How_can_I_build_my_MSVC_application_with_a_static_runtime.3F
  if (MSVC AND protobuf_MSVC_STATIC_RUNTIME)
    foreach(flag_var
        CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
        CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif(${flag_var} MATCHES "/MD")
    endforeach(flag_var)
  endif (MSVC AND protobuf_MSVC_STATIC_RUNTIME)
endif (protobuf_BUILD_SHARED_LIBS)

if (MSVC)
  # Build with multiple processes
  add_definitions(/MP)
  # MSVC warning suppressions
  add_definitions(
    /wd4018 # 'expression' : signed/unsigned mismatch
    /wd4065 # switch statement contains 'default' but no 'case' labels
    /wd4146 # unary minus operator applied to unsigned type, result still unsigned
    /wd4244 # 'conversion' conversion from 'type1' to 'type2', possible loss of data
    /wd4251 # 'identifier' : class 'type' needs to have dll-interface to be used by clients of class 'type2'
    /wd4267 # 'var' : conversion from 'size_t' to 'type', possible loss of data
    /wd4305 # 'identifier' : truncation from 'type1' to 'type2'
    /wd4307 # 'operator' : integral constant overflow
    /wd4309 # 'conversion' : truncation of constant value
    /wd4334 # 'operator' : result of 32-bit shift implicitly converted to 64 bits (was 64-bit shift intended?)
    /wd4355 # 'this' : used in base member initializer list
    /wd4506 # no definition for inline function 'function'
    /wd4800 # 'type' : forcing value to bool 'true' or 'false' (performance warning)
    /wd4996 # The compiler encountered a deprecated declaration.
  )
  # Allow big object
  add_definitions(/bigobj)
  string(REPLACE "/" "\\" PROTOBUF_SOURCE_WIN32_PATH ${protobuf_SOURCE_DIR})
  string(REPLACE "/" "\\" PROTOBUF_BINARY_WIN32_PATH ${protobuf_BINARY_DIR})
  configure_file(extract_includes.bat.in extract_includes.bat)
  
  # Suppress linker warnings about files with no symbols defined.
  set(CMAKE_STATIC_LINKER_FLAGS /ignore:4221)
endif (MSVC)

get_filename_component(protobuf_source_dir ${protobuf_SOURCE_DIR} PATH)

include_directories(
  ${ZLIB_INCLUDE_DIRECTORIES}
  ${protobuf_BINARY_DIR}
  ${protobuf_source_dir}/src)

if (MSVC)
  # Add the "lib" prefix for generated .lib outputs.
  set(LIB_PREFIX lib)
else (MSVC)
  # When building with "make", "lib" prefix will be added automatically by
  # the build tool.
  set(LIB_PREFIX)
endif (MSVC)

if (protobuf_UNICODE)
  add_definitions(-DUNICODE -D_UNICODE)
endif (protobuf_UNICODE)

include(libprotobuf-lite.cmake)
include(libprotobuf.cmake)
if (protobuf_BUILD_PROTOC_BINARIES)
  include(libprotoc.cmake)
  include(protoc.cmake)
endif (protobuf_BUILD_PROTOC_BINARIES)

if (protobuf_BUILD_TESTS)
  include(tests.cmake)
endif (protobuf_BUILD_TESTS)

include(install.cmake)

if (protobuf_BUILD_EXAMPLES)
  include(examples.cmake)
endif (protobuf_BUILD_EXAMPLES)

if(protobuf_VERBOSE)
    message(STATUS "Protocol Buffers Configuring done")
endif()

=== third_party/perf_data_converter/third_party/protobuf/third_party/benchmark/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.11)
project (benchmark)

foreach(p
    CMP0054 # CMake 3.1
    )
  if(POLICY ${p})
    cmake_policy(SET ${p} NEW)
  endif()
endforeach()

option(BENCHMARK_ENABLE_TESTING "Enable testing of the benchmark library." ON)
option(BENCHMARK_ENABLE_LTO "Enable link time optimisation of the benchmark library." OFF)
# Make sure we can import out CMake functions
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# Read the git tags to determine the project version
include(GetGitVersion)
get_git_version(GIT_VERSION)

# Tell the user what versions we are using
string(REGEX MATCH "[0-9]+\\.[0-9]+\\.[0-9]+" VERSION ${GIT_VERSION})
message("-- Version: ${VERSION}")

# The version of the libraries
set(GENERIC_LIB_VERSION ${VERSION})
string(SUBSTRING ${VERSION} 0 1 GENERIC_LIB_SOVERSION)

# Import our CMake modules
include(CheckCXXCompilerFlag)
include(AddCXXCompilerFlag)
include(CXXFeatureCheck)

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  # Turn compiler warnings up to 11
  string(REGEX REPLACE "[-/]W[1-4]" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)

  # Link time optimisation
  if (BENCHMARK_ENABLE_LTO)
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /GL")
    set(CMAKE_STATIC_LINKER_FLAGS_RELEASE "${CMAKE_STATIC_LINKER_FLAGS_RELEASE} /LTCG")
    set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /LTCG")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")

    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /GL")
    string(REGEX REPLACE "[-/]INCREMENTAL" "/INCREMENTAL:NO" CMAKE_STATIC_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_STATIC_LINKER_FLAGS_RELWITHDEBINFO}")
    set(CMAKE_STATIC_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_STATIC_LINKER_FLAGS_RELWITHDEBINFO} /LTCG")
    string(REGEX REPLACE "[-/]INCREMENTAL" "/INCREMENTAL:NO" CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO}")
    set(CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO} /LTCG")
    string(REGEX REPLACE "[-/]INCREMENTAL" "/INCREMENTAL:NO" CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO}")
    set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO} /LTCG")

    set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} /GL")
    set(CMAKE_STATIC_LINKER_FLAGS_MINSIZEREL "${CMAKE_STATIC_LINKER_FLAGS_MINSIZEREL} /LTCG")
    set(CMAKE_SHARED_LINKER_FLAGS_MINSIZEREL "${CMAKE_SHARED_LINKER_FLAGS_MINSIZEREL} /LTCG")
    set(CMAKE_EXE_LINKER_FLAGS_MINSIZEREL "${CMAKE_EXE_LINKER_FLAGS_MINSIZEREL} /LTCG")
  endif()
else()
  # Try and enable C++11. Don't use C++14 because it doesn't work in some
  # configurations.
  add_cxx_compiler_flag(-std=c++11)
  if (NOT HAVE_CXX_FLAG_STD_CXX11)
    add_cxx_compiler_flag(-std=c++0x)
  endif()

  # Turn compiler warnings up to 11
  add_cxx_compiler_flag(-Wall)

  add_cxx_compiler_flag(-Wextra)
  add_cxx_compiler_flag(-Wshadow)
  add_cxx_compiler_flag(-Werror RELEASE)
  add_cxx_compiler_flag(-Werror RELWITHDEBINFO)
  add_cxx_compiler_flag(-Werror MINSIZEREL)
  add_cxx_compiler_flag(-pedantic)
  add_cxx_compiler_flag(-pedantic-errors)
  add_cxx_compiler_flag(-Wshorten-64-to-32)
  add_cxx_compiler_flag(-Wfloat-equal)
  add_cxx_compiler_flag(-Wzero-as-null-pointer-constant)
  add_cxx_compiler_flag(-fstrict-aliasing)
  if (HAVE_CXX_FLAG_FSTRICT_ALIASING)
    add_cxx_compiler_flag(-Wstrict-aliasing)
  endif()
  add_cxx_compiler_flag(-Wthread-safety)
  if (HAVE_WTHREAD_SAFETY)
    add_definitions(-DHAVE_WTHREAD_SAFETY)
    cxx_feature_check(THREAD_SAFETY_ATTRIBUTES)
  endif()

  # Link time optimisation
  if (BENCHMARK_ENABLE_LTO)
    add_cxx_compiler_flag(-flto)
    if ("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
      find_program(GCC_AR gcc-ar)
      if (GCC_AR)
        set(CMAKE_AR ${GCC_AR})
      endif()
      find_program(GCC_RANLIB gcc-ranlib)
      if (GCC_RANLIB)
        set(CMAKE_RANLIB ${GCC_RANLIB})
      endif()
    endif()
  endif()

  # Coverage build type
  set(CMAKE_CXX_FLAGS_COVERAGE "${CMAKE_CXX_FLAGS_DEBUG}" CACHE STRING
    "Flags used by the C++ compiler during coverage builds."
    FORCE)
  set(CMAKE_EXE_LINKER_FLAGS_COVERAGE
    "${CMAKE_EXE_LINKER_FLAGS_DEBUG}" CACHE STRING
    "Flags used for linking binaries during coverage builds."
    FORCE)
  set(CMAKE_SHARED_LINKER_FLAGS_COVERAGE
    "${CMAKE_SHARED_LINKER_FLAGS_DEBUG}" CACHE STRING
    "Flags used by the shared libraries linker during coverage builds."
    FORCE)
  mark_as_advanced(
    CMAKE_CXX_FLAGS_COVERAGE
    CMAKE_EXE_LINKER_FLAGS_COVERAGE
    CMAKE_SHARED_LINKER_FLAGS_COVERAGE)
  set(CMAKE_BUILD_TYPE "${CMAKE_BUILD_TYPE}" CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel Coverage."
    FORCE)
  add_cxx_compiler_flag(--coverage COVERAGE)
endif()

# C++ feature checks
cxx_feature_check(STD_REGEX)
cxx_feature_check(GNU_POSIX_REGEX)
cxx_feature_check(POSIX_REGEX)
cxx_feature_check(STEADY_CLOCK)

# Ensure we have pthreads
find_package(Threads REQUIRED)

# Set up directories
include_directories(${PROJECT_SOURCE_DIR}/include)

# Build the targets
add_subdirectory(src)

if (BENCHMARK_ENABLE_TESTING)
  enable_testing()
  add_subdirectory(test)
endif()

=== debian/changelog ===
autofdo (0.19-4) unstable; urgency=medium

  * QA upload.
  * Maintain package in Debian team on Salsa
  * d/watch: version=5
  * Standards-Version: 4.7.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Secure URI in copyright format (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * Refer to common license file for Apache-2.0.
  * Move source package lintian overrides to debian/source.
  * Add debian/upstream/metadata
  * Fix clean target
    Closes: #1044038

 -- Andreas Tille <tille@debian.org>  Wed, 03 Dec 2025 20:13:44 +0100

autofdo (0.19-3) unstable; urgency=medium

  * QA upload.
  * Orphan the package. See #1041473.

 -- Matthias Klose <doko@debian.org>  Sat, 19 Aug 2023 11:11:12 +0200

autofdo (0.19-2.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Build without LLVM support (Closes: #1017677)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 25 Jul 2023 14:04:07 +0200

autofdo (0.19-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Build with LLVM 13. (Closes: #1016238)

 -- Adrian Bunk <bunk@debian.org>  Tue, 13 Sep 2022 23:41:57 +0300

autofdo (0.19-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Use the default LLVM. (Closes: #974802)
  * Backport upstream fix for FTBFS with LLVM 11.
  * Use the system libprotobuf. (Closes: #960822)
  * Remove vendored copies in dh_auto_clean,
    fixes building twice in a row.

 -- Adrian Bunk <bunk@debian.org>  Thu, 07 Oct 2021 15:13:26 +0300

autofdo (0.19-2) unstable; urgency=medium

  * Link with -latomic where needed.

 -- Matthias Klose <doko@debian.org>  Mon, 28 Oct 2019 11:28:07 +0100

autofdo (0.19-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Sun, 27 Oct 2019 21:01:09 +0200

autofdo (0.18-2) unstable; urgency=medium

  * Bump standards version.
  * Build using LLVM 7. Closes: #912800.

 -- Matthias Klose <doko@debian.org>  Mon, 05 Nov 2018 08:20:51 +0100

=== debian/control ===
Source: autofdo
Section: devel
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 13),
  libssl-dev, zlib1g-dev,
  libgoogle-glog-dev, libgflags-dev,
  libelf-dev,
  protobuf-compiler,
  libprotobuf-dev,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian/autofdo
Vcs-Git: https://salsa.debian.org/debian/autofdo.git
Homepage: https://github.com/google/autofdo

Package: autofdo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AutoFDO Profile Toolchain
 The package contains a tool to convert perf.data profile to AutoFDO
 profile that can be used by GCC and LLVM.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_clean:
	rm -rf gflags
	rm -rf glog
	rm -rf third_party/protobuf
	dh_auto_clean

=== debian/watch ===
Version: 5

Template: Github
Owner: google
Project: autofdo
